org.apache.poi.sl.draw

## Class DrawTextParagraph

- java.lang.Object
- - org.apache.poi.sl.draw.DrawTextParagraph

- All Implemented Interfaces:
    Drawable

      public class DrawTextParagraph
      extends java.lang.Object
      implements Drawable

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.poi.sl.draw.Drawable

      `Drawable.DrawableHint`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `autoNbrIdx`
    `protected DrawTextFragment` | `bullet`
    `static org.apache.poi.sl.draw.DrawTextParagraph.XlinkAttribute` | `HYPERLINK_HREF` Keys for passing hyperlinks to the graphics context
    `static org.apache.poi.sl.draw.DrawTextParagraph.XlinkAttribute` | `HYPERLINK_LABEL`
    `protected java.util.List<DrawTextFragment>` | `lines`
    `protected double` | `maxLineHeight` the highest line in this paragraph.
    `protected TextParagraph<?,?,?>` | `paragraph`
    `protected java.lang.String` | `rawText`

    - ### Fields inherited from interface org.apache.poi.sl.draw.Drawable

      `BUFFERED_IMAGE, CURRENT_SLIDE, DRAW_FACTORY, FONT_FALLBACK, FONT_HANDLER, FONT_MAP, GRADIENT_SHAPE, GRESTORE, GROUP_TRANSFORM, GSAVE, IMAGE_RENDERER, PRESET_GEOMETRY_CACHE, TEXT_AS_CHARACTERS, TEXT_AS_SHAPES, TEXT_RENDERING_MODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawTextParagraph(TextParagraph<?,?,?> paragraph)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `applyTransform(java.awt.Graphics2D graphics)` Apply 2-D transforms before drawing this shape.
    `protected void` | `breakText(java.awt.Graphics2D graphics)` break text into lines, each representing a line of text that fits in the wrapping width
    `void` | `draw(java.awt.Graphics2D graphics)` Draw this shape into the supplied canvas
    `void` | `drawContent(java.awt.Graphics2D graphics)` draw any content within this shape (image, text, etc.).
    `protected java.text.AttributedString` | `getAttributedString(java.awt.Graphics2D graphics, java.lang.StringBuilder text)`
    `protected DrawTextFragment` | `getBullet(java.awt.Graphics2D graphics, java.text.AttributedCharacterIterator firstLineAttr)`
    `float` | `getFirstLineHeight()`
    `float` | `getFirstLineLeading()`
    `float` | `getLastLineHeight()`
    `protected java.lang.String` | `getRenderableText(java.awt.Graphics2D graphics, TextRun tr)`
    `java.lang.String` | `getRenderableText(TextRun tr)`
    `protected double` | `getWrappingWidth(boolean firstLine, java.awt.Graphics2D graphics)` Returns wrapping width to break lines in this paragraph
    `double` | `getY()`
    `boolean` | `isEmptyParagraph()`
    `protected boolean` | `isHSLF()`
    `void` | `setAutoNumberingIdx(int index)` Sets the auto numbering index of the handled paragraph
    `void` | `setPosition(double x, double y)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### HYPERLINK_HREF

          public static final org.apache.poi.sl.draw.DrawTextParagraph.XlinkAttribute HYPERLINK_HREF

      Keys for passing hyperlinks to the graphics context

    - #### HYPERLINK_LABEL

          public static final org.apache.poi.sl.draw.DrawTextParagraph.XlinkAttribute HYPERLINK_LABEL

    - #### paragraph

          protected TextParagraph<?,?,?> paragraph

    - #### lines

          protected java.util.List<DrawTextFragment> lines

    - #### rawText

          protected java.lang.String rawText

    - #### bullet

          protected DrawTextFragment bullet

    - #### autoNbrIdx

          protected int autoNbrIdx

    - #### maxLineHeight

          protected double maxLineHeight

      the highest line in this paragraph. Used for line spacing.

  - ### Constructor Detail

    - #### DrawTextParagraph

          public DrawTextParagraph(TextParagraph<?,?,?> paragraph)

  - ### Method Detail

    - #### setPosition

          public void setPosition(double x,
                                  double y)

    - #### getY

          public double getY()

    - #### setAutoNumberingIdx

          public void setAutoNumberingIdx(int index)

      Sets the auto numbering index of the handled paragraph
      Parameters:
        `index` - the auto numbering index

    - #### draw

          public void draw(java.awt.Graphics2D graphics)

      Description copied from interface: `Drawable`
      Draw this shape into the supplied canvas
      Specified by:
        `draw` in interface `Drawable`
      Parameters:
        `graphics` - the graphics to draw into

    - #### getFirstLineLeading

          public float getFirstLineLeading()

    - #### getFirstLineHeight

          public float getFirstLineHeight()

    - #### getLastLineHeight

          public float getLastLineHeight()

    - #### isEmptyParagraph

          public boolean isEmptyParagraph()

    - #### applyTransform

          public void applyTransform(java.awt.Graphics2D graphics)

      Description copied from interface: `Drawable`
      Apply 2-D transforms before drawing this shape. This includes rotation and flipping.
      Specified by:
        `applyTransform` in interface `Drawable`
      Parameters:
        `graphics` - the graphics whos transform matrix will be modified

    - #### drawContent

          public void drawContent(java.awt.Graphics2D graphics)

      Description copied from interface: `Drawable`
      draw any content within this shape (image, text, etc.).
      Specified by:
        `drawContent` in interface `Drawable`
      Parameters:
        `graphics` - the graphics to draw into

    - #### breakText

          protected void breakText(java.awt.Graphics2D graphics)

      break text into lines, each representing a line of text that fits in the wrapping width
      Parameters:
        `graphics` - The drawing context for computing text-lengths.

    - #### getBullet

          protected DrawTextFragment getBullet(java.awt.Graphics2D graphics,
                                               java.text.AttributedCharacterIterator firstLineAttr)

    - #### getRenderableText

          protected java.lang.String getRenderableText(java.awt.Graphics2D graphics,
                                                       TextRun tr)

    - #### getRenderableText

          @Internal
          public java.lang.String getRenderableText(TextRun tr)

    - #### getWrappingWidth

          protected double getWrappingWidth(boolean firstLine,
                                            java.awt.Graphics2D graphics)

      Returns wrapping width to break lines in this paragraph
      Parameters:
        `firstLine` - whether the first line is breaking
      Returns:
        wrapping width in points

    - #### getAttributedString

          protected java.text.AttributedString getAttributedString(java.awt.Graphics2D graphics,
                                                                   java.lang.StringBuilder text)

    - #### isHSLF

          protected boolean isHSLF()

      Returns:
        `true` if the HSLF implementation is used

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.